async function getOptionCollection() {
    let promise = new Promise(function(resolve, reject) {
        chrome.storage.sync.get(['gdprOptionList'], function (result) {
            result = result.gdprOptionList;
            if(result === undefined) {
                result = {};
            }

            resolve(result);
        });
    });

    return await promise;
}

async function getCategoryCollection() {
    let promise = new Promise(function(resolve, reject) {
        chrome.storage.sync.get(['gdprCategoryList'], function (result) {
            result = result.gdprCategoryList;
            if(result === undefined) {
                result = {};
            }

            resolve(result);
        });
    });

    return await promise;
}

async function getCurrentTab() {
    let promise = new Promise(function(resolve, reject) {
        let params = {
            active: true,
            currentWindow: true
        };
        chrome.tabs.query(params, function (tabs) {
            resolve(tabs[0]);
        });
    });

    return await promise;
}

async function getAutoAcceptWhenKnown() {
    let promise = new Promise(function(resolve, reject) {
        chrome.storage.sync.get(['autoAcceptWhenKnown'], function (result) {
            result = result.autoAcceptWhenKnown;
            if(result === undefined) {
                result = 0;
            }

            resolve(result);
        });
    });

    return await promise;
}

async function getAutoAccept() {
    let promise = new Promise(function(resolve, reject) {
        chrome.storage.sync.get(['autoAccept'], function (result) {
            result = result.autoAccept;
            if(result === undefined) {
                result = 0;
            }

            resolve(result);
        });
    });

    return await promise;
}