function receiveBrowserExtensionMessage(request, sender, sendResponse) {
    let data = request.data ? request.data : {};
    switch(request.action) {
        case 'update':
            break;
        case'add_and_load_accepted_gdpr_options':
        case 'load_gdpr_accept':
            if(data.autoAccept) {
                let button = document.getElementById('accept-all');
                if(button) {
                    button.click();
                }
                return;
            }

            for(let keyName in data.items) {
                if(data.items.hasOwnProperty(keyName)) {
                    let chk = document.getElementsByClassName('key-item-' + keyName)[0];
                    if(chk) {
                        chk.checked = data.items[keyName].enabled;
                    }
                }
            }

            if(data.autoAcceptWhenKnown && Object.keys(getPageGdprItems()).length === Object.keys(data).length) {
                let button = document.getElementById('privacy-accepted');
                if(button) {
                    button.click();
                }
            }
            break;
        case 'reload_page':
            window.location.reload();
            break;
        case 'debug':
            console.log(request);
            break;
    }

    //i'm only a receiver but i send a empty response to confirm the data.
    sendResponse({});
}

function onload() {
    send({action:'add_and_load_accepted_gdpr_options', data:getPageGdprItems(), categories: getPageGdprCategories()}, function(response) { });
}

function getPageGdprItems() {
    let list = document.getElementsByClassName('gdpr-item');
    let ruleList = {};
    for(let ii = 0; ii < list.length; ii++) {
        let item = list[ii];
        if(item.getAttribute('data-key').length > 0) {
            ruleList[item.getAttribute('data-key')] = {
                label: item.getAttribute('data-label'),
                category: item.getAttribute('data-category'),
                domain: window.location.hostname,
                enabled: item.checked || item.hasAttribute('readonly'),
                required: item.hasAttribute('readonly')
            };
        }
    }

    return ruleList;
}

function getPageGdprCategories() {
    let ruleList = {};
    let list = document.getElementsByClassName('gdpr-category-item');

    for(let ii = 0; ii < list.length; ii++) {
        let item = list[ii];
            ruleList[item.getAttribute('data-category')] = {
                label: item.textContent,
                category: item.getAttribute('data-category'),
                required: item.getAttribute('data-category') === 'required'
            };
    }

    return ruleList;
}

function submitGdprForm(event) {
    if (event.source !== window)
        return;

    if (event.data.type && (event.data.type === "GDPR_SUBMIT")) {
        send({action: 'update', data: event.data.data}, function() {});
    }
}

window.addEventListener("message", submitGdprForm);
chrome.runtime.onMessage.addListener(receiveBrowserExtensionMessage);

function send(data, callback) {
    chrome.runtime.sendMessage(data, callback);
}

(function() {
    onload();
})();