let requestResponseActions = {};

function send(action, data, callback) {
    if(data instanceof Function) {
        callback = data;
        data = {action: action, data:{}};
    } else {
        data = {
            action: action,
            data: data
        };
    }

    requestResponseActions[action] = callback;
    chrome.runtime.sendMessage(data, () => {});
}

function receive(callback) {
    chrome.runtime.onMessage.addListener(callback);
}

function getDomain(url) {
    let host = url.replace('http://', '').replace('https://', '');
    if((host.length - 1) === host.lastIndexOf('/')) {
        host = host.substr(0, host.length - 1);
    }

    return host;
}

function render(data, tpl) {
    let content = templates[tpl];

    let translations = false;
    do {
        translations = content.match('__\\(\\\'(.*?)\\\'\\)');
        if(translations) {
            content = content.replace(translations[0], translate(translations[1]))
        }
        //console.log(translations);
    } while(translations);

    for(let name in data) {
        if(data.hasOwnProperty(name)) {
            content = content.split("{{" + name + "}}").join(data[name]);
        }
    }

    return content;
}

function translate(key) {
    if(trans[container.language] && trans[container.language][key]) {
        return trans[container.language][key];
    }

    return 'Missing Translation';
}

receive(function(request, sender, sendResponse) {
    let data = request.data ? request.data : {};
    requestResponseActions[request.action](data);
    sendResponse({});
});